Attribute VB_Name = "mdlModule"
'Created by Pieter Philippaerts
'KPD-Team 1999
'URL: http://users.turboline.be/btl10148/
'E-Mail: KPD_Team@Hotmail.com

Type PALETTEENTRY
    peRed As Byte
    peGreen As Byte
    peBlue As Byte
    peFlags As Byte
End Type
Type LOGPALETTE
    palVersion As Integer
    palNumEntries As Integer
    palPalEntry(255) As PALETTEENTRY ' Enough for 256 colors
End Type
Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type
Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Type PicBmp
    Size As Long
    Type As Long
    hBmp As Long
    hPal As Long
    Reserved As Long
End Type
Type tRGB
    R As Long
    G As Long
    B As Long
End Type

Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal iCapabilitiy As Long) As Long
Declare Function GetSystemPaletteEntries Lib "gdi32" (ByVal hdc As Long, ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As PALETTEENTRY) As Long
Declare Function CreatePalette Lib "gdi32" (lpLogPalette As LOGPALETTE) As Long
Declare Function GetForegroundWindow Lib "user32" () As Long
Declare Function SelectPalette Lib "gdi32" (ByVal hdc As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Declare Function RealizePalette Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function GetWindowDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Declare Function GetDesktopWindow Lib "user32" () As Long
Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (PicDesc As PicBmp, RefIID As GUID, ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long
Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long
Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function SetPixelV Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Declare Function InvertRect Lib "user32" (ByVal hdc As Long, lpRect As RECT) As Long
Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal H As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal I As Long, ByVal u As Long, ByVal S As Long, ByVal C As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long
Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Declare Function MulDiv Lib "kernel32" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long
Declare Function DrawEdge Lib "user32" (ByVal hdc As Long, qrc As RECT, ByVal Edge As Long, ByVal grfFlags As Long) As Long
Declare Function DrawFocusRect Lib "user32" (ByVal hdc As Long, lpRect As RECT) As Long
Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Public Const COLOR_BTNFACE = 15
Public Const RC_PALETTE As Long = &H100
'Used with GetDeviceCaps
Public Const LOGPIXELSY = 90
Public Const SIZEPALETTE As Long = 104
Public Const RASTERCAPS As Long = 38
'Used for the Bold-parameter
Enum eBold
    FW_DONTCARE = 0
    FW_THIN = 100
    FW_EXTRALIGHT = 200
    FW_LIGHT = 300
    FW_NORMAL = 400
    FW_MEDIUM = 500
    FW_SEMIBOLD = 600
    FW_BOLD = 700
    FW_EXTRABOLD = 800
    FW_HEAVY = 900
End Enum
'Used for the parameter
Enum eCharSet
    ANSI_CHARSET = 0
    DEFAULT_CHARSET = 1
    SYMBOL_CHARSET = 2
    SHIFTJIS_CHARSET = 128
    HANGEUL_CHARSET = 129
    CHINESEBIG5_CHARSET = 136
    OEM_CHARSET = 255
End Enum
'Used for the Precision parameter
Enum ePrecision
    OUT_CHARACTER_PRECIS = 2
    OUT_DEFAULT_PRECIS = 0
    OUT_DEVICE_PRECIS = 5
    OUT_OUTLINE_PRECIS = 8
    OUT_RASTER_PRECIS = 6
    OUT_STRING_PRECIS = 1
    OUT_STROKE_PRECIS = 3
    OUT_TT_ONLY_PRECIS = 7
    OUT_TT_PRECIS = 4
End Enum
'Used for the ClipPrecision parameter
Public Const CLIP_DEFAULT_PRECIS = 0
'Used for the Quality parameter
Enum eQuality
    DEFAULT_QUALITY = 0
    DRAFT_QUALITY = 1
    PROOF_QUALITY = 2
End Enum
Enum eEdge
    BDR_INNER = &HC
    BDR_OUTER = &H3
    BDR_RAISED = &H5
    BDR_RAISEDINNER = &H4
    BDR_RAISEDOUTER = &H1
    BDR_SUNKEN = &HA
    BDR_SUNKENINNER = &H8
    BDR_SUNKENOUTER = &H2
    EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)
    EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
    EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
    EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
End Enum
'Used with DrawEdge
Public Const BF_RIGHT = &H4
Public Const BF_TOP = &H2
Public Const BF_LEFT = &H1
Public Const BF_BOTTOM = &H8
Public Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
'used for the PitchAndFamily parameter
Public Const DEFAULT_PITCH = 0
Public Function CreateBitmapPicture(ByVal hBmp As Long, ByVal hPal As Long) As Picture
    Dim R As Long
    Dim Pic As PicBmp
    Dim IPic As IPicture
    Dim IID_IDispatch As GUID

    With IID_IDispatch
        .Data1 = &H20400
        .Data4(0) = &HC0
        .Data4(7) = &H46
    End With

    With Pic
        .Size = Len(Pic) ' Length of structure
        .Type = vbPicTypeBitmap ' Type of Picture (bitmap)
        .hBmp = hBmp ' Handle to bitmap
        .hPal = hPal ' Handle to palette (may be null)
    End With

    R = OleCreatePictureIndirect(Pic, IID_IDispatch, 1, IPic)

    Set CreateBitmapPicture = IPic
End Function
Public Function hDCToPicture(ByVal hDCSrc As Long, ByVal LeftSrc As Long, ByVal TopSrc As Long, ByVal WidthSrc As Long, ByVal HeightSrc As Long) As Picture
    Dim hDCMemory As Long
    Dim hBmp As Long
    Dim hBmpPrev As Long
    Dim R As Long
    Dim hPal As Long
    Dim hPalPrev As Long
    Dim RasterCapsScrn As Long
    Dim HasPaletteScrn As Long
    Dim PaletteSizeScrn As Long
    Dim LogPal As LOGPALETTE

    hDCMemory = CreateCompatibleDC(hDCSrc)
    hBmp = CreateCompatibleBitmap(hDCSrc, WidthSrc, HeightSrc)
    hBmpPrev = SelectObject(hDCMemory, hBmp)

    RasterCapsScrn = GetDeviceCaps(hDCSrc, RASTERCAPS) ' Raster
    HasPaletteScrn = RasterCapsScrn And RC_PALETTE ' Palette
    PaletteSizeScrn = GetDeviceCaps(hDCSrc, SIZEPALETTE) ' Size of

    If HasPaletteScrn And (PaletteSizeScrn = 256) Then
        LogPal.palVersion = &H300
        LogPal.palNumEntries = 256
        R = GetSystemPaletteEntries(hDCSrc, 0, 256, LogPal.palPalEntry(0))
        hPal = CreatePalette(LogPal)
        hPalPrev = SelectPalette(hDCMemory, hPal, 0)
        R = RealizePalette(hDCMemory)
    End If
    
    R = BitBlt(hDCMemory, 0, 0, WidthSrc, HeightSrc, hDCSrc, LeftSrc, TopSrc, vbSrcCopy)
    
    hBmp = SelectObject(hDCMemory, hBmpPrev)
    
    If HasPaletteScrn And (PaletteSizeScrn = 256) Then
        hPal = SelectPalette(hDCMemory, hPalPrev, 0)
    End If
    
    R = DeleteDC(hDCMemory)

    Set hDCToPicture = CreateBitmapPicture(hBmp, hPal)
End Function
Function EarthQuake(lhSrcDC As Long, nWidth As Integer, nHeight As Integer, nSize As Integer, lhDestDC As Long) As Boolean
    Dim CopyDC As Long, CopyBitmap As Long, y As Integer
    CopyDC = CreateCompatibleDC(lhSrcDC)
    CopyBitmap = CreateCompatibleBitmap(lhSrcDC, nWidth, nHeight)
    If SelectObject(CopyDC, CopyBitmap) = 0 Then Exit Function
    
    For y = 0 To nHeight - 1 Step 2
        BitBlt CopyDC, nSize, y, nWidth - nSize, 1, lhSrcDC, 0, y, vbSrcCopy
        BitBlt CopyDC, 0, y, nSize, 1, lhSrcDC, nWidth - nSize, y, vbSrcCopy
        BitBlt CopyDC, 0, y + 1, nWidth - nSize, 1, lhSrcDC, nSize, y + 1, vbSrcCopy
        BitBlt CopyDC, nWidth - nSize, y + 1, nSize, 1, lhSrcDC, 0, y + 1, vbSrcCopy
    Next y
    
    If BitBlt(lhDestDC, 0, 0, nWidth, nHeight, CopyDC, 0, 0, vbSrcCopy) = 0 Then Exit Function
  
    DeleteDC CopyDC
    DeleteObject CopyBitmap
    EarthQuake = True
End Function
Function CreateMask(hSrcDC As Long, nWidth As Integer, nHeight As Integer, hDestDC As Long, MaskColor As Long) As Boolean
    Dim MonoDC As Long, MonoBitmap As Long, OldBkColor As Long
    MonoDC = CreateCompatibleDC(hSrcDC)
    MonoBitmap = CreateBitmap(nWidth, nHeight, 1, 1, ByVal 0&)
    If SelectObject(MonoDC, MonoBitmap) = 0 Then Exit Function

    OldBkColor = SetBkColor(hSrcDC, MaskColor)
    BitBlt MonoDC, 0, 0, nWidth, nHeight, hSrcDC, 0, 0, vbSrcCopy
    If BitBlt(hDestDC, 0, 0, nWidth, nHeight, MonoDC, 0, 0, vbSrcCopy) = 0 Then Exit Function

    SetBkColor hSrcDC, OldBkColor
    DeleteObject MonoBitmap
    DeleteDC MonoDC
    CreateMask = True
End Function
Function LongToRGB(nColor As Long) As tRGB
    LongToRGB.B = Int(nColor / 65536)
    nColor = nColor - LongToRGB.B * 65536
    LongToRGB.G = Int(nColor / 256)
    LongToRGB.R = nColor - LongToRGB.G * 256
End Function
Function MixPictures(FirstPic As Long, nWidth1 As Integer, nHeight1 As Integer, SecPic As Long, nWidth2 As Integer, nHeight2 As Integer, hDestDC As Long) As Boolean
    Dim CopyDC As Long, CopyBitmap As Long, XSize As Integer, YSize As Integer
    Dim C1 As tRGB, C2 As tRGB, x As Integer, y As Integer

    XSize = IIf(nWidth1 > nWidth2, nWidth1, nWidth2)
    YSize = IIf(nHeight1 > nHeight2, nHeight1, nHeight2)

    CopyDC = CreateCompatibleDC(FirstPic)
    CopyBitmap = CreateCompatibleBitmap(FirstPic, XSize, YSize)
    If SelectObject(CopyDC, CopyBitmap) = 0 Then Exit Function
    
    For x = 0 To XSize - 1
        For y = 0 To YSize - 1
            C1 = LongToRGB(GetPixel(FirstPic, x, y))
            C2 = LongToRGB(GetPixel(SecPic, x, y))
            SetPixelV CopyDC, x, y, RGB((C1.R + C2.R) / 2, (C1.G + C2.G) / 2, (C1.B + C2.B) / 2)
        Next y
    Next x
    
    If BitBlt(hDestDC, 0, 0, XSize, YSize, CopyDC, 0, 0, vbSrcCopy) = 0 Then Exit Function

    DeleteObject CopyBitmap
    DeleteDC CopyDC
    MixPictures = True
End Function
Function DrawPattern(hSrcDC As Long, nWidth As Integer, nHeight As Integer, hPatternDC As Long, MaskColor As Long, hDestDC As Long, bInvert As Boolean) As Boolean
    Dim MaskDC As Long, ResDC As Long, MaskBitmap As Long, ResBitmap As Long, R As RECT, mBrush As Long
    MaskDC = CreateCompatibleDC(hSrcDC)
    MaskBitmap = CreateBitmap(nWidth, nHeight, 1, 1, ByVal 0&)
    If SelectObject(MaskDC, MaskBitmap) = 0 Then Exit Function
    ResDC = CreateCompatibleDC(hSrcDC)
    ResBitmap = CreateCompatibleBitmap(hSrcDC, nWidth, nHeight)
    If SelectObject(ResDC, ResBitmap) = 0 Then Exit Function
    
    If CreateMask(hSrcDC, nWidth, nHeight, MaskDC, MaskColor) = False Then Exit Function
    mBrush = CreateSolidBrush(vbWhite)
    SetRect R, 0, 0, nWidth, nHeight
    If FillRect(ResDC, R, mBrush) = False Then Exit Function

    If bInvert = True Then
        If InvertRect(MaskDC, R) = 0 Then Exit Function
    End If
    
    BitBlt ResDC, 0, 0, nWidth, nHeight, MaskDC, 0, 0, vbSrcAnd
    BitBlt ResDC, 0, 0, nWidth, nHeight, hPatternDC, 0, 0, vbSrcPaint
    If BitBlt(hDestDC, 0, 0, nWidth, nHeight, ResDC, 0, 0, vbSrcCopy) = 0 Then Exit Function
    
    DeleteDC MaskDC
    DeleteDC ResDC
    DeleteObject MaskBitmap
    DeleteObject ResBitmap
    DeleteObject mBrush
    DrawPattern = True
End Function
Function DuoTone(hSrcDC As Long, nWidth As Integer, nHeight As Integer, DuoColor As Long, hDestDC As Long) As Boolean
    Dim CopyDC As Long, CopyBitmap As Long, mBrush As Long, R As RECT
    CopyDC = CreateCompatibleDC(hSrcDC)
    CopyBitmap = CreateCompatibleBitmap(hSrcDC, nWidth, nHeight)
    If SelectObject(CopyDC, CopyBitmap) = 0 Then Exit Function
    
    SetRect R, 0, 0, nWidth, nHeight
    mBrush = CreateSolidBrush(DuoColor)
    If FillRect(CopyDC, R, mBrush) = 0 Then Exit Function
    
    BitBlt CopyDC, 0, 0, nWidth, nHeight, hSrcDC, 0, 0, vbSrcAnd
    If BitBlt(hDestDC, 0, 0, nWidth, nHeight, CopyDC, 0, 0, vbSrcCopy) = 0 Then Exit Function

    DeleteObject mBrush
    DeleteObject CopyBitmap
    DeleteDC CopyDC
    DuoTone = True
End Function
Function TransBlt(hSrcDC As Long, lWidth As Integer, lHeight As Integer, MaskColor As Long, hBackDC As Long, hDestDC As Long) As Boolean
    Dim MonoDC As Long, MonoBitmap As Long, CopyDC As Long, CopyBitmap As Long
    Dim AndDC As Long, AndBitmap As Long, R As RECT

    MonoDC = CreateCompatibleDC(hSrcDC)
    MonoBitmap = CreateBitmap(lWidth, lHeight, 1, 1, ByVal 0&)
    If SelectObject(MonoDC, MonoBitmap) = 0 Then Exit Function
    If CreateMask(hSrcDC, lWidth, lHeight, MonoDC, MaskColor) = 0 Then Exit Function

    CopyDC = CreateCompatibleDC(hSrcDC)
    CopyBitmap = CreateCompatibleBitmap(hSrcDC, lWidth, lHeight)
    If SelectObject(CopyDC, CopyBitmap) = 0 Then Exit Function
    
    AndDC = CreateCompatibleDC(hSrcDC)
    AndBitmap = CreateCompatibleBitmap(hSrcDC, lWidth, lHeight)
    If SelectObject(AndDC, AndBitmap) = 0 Then Exit Function
    BitBlt AndDC, 0, 0, lWidth, lHeight, hSrcDC, 0, 0, vbSrcCopy

    BitBlt CopyDC, 0, 0, lWidth, lHeight, hBackDC, 0, 0, vbSrcCopy
    BitBlt CopyDC, 0, 0, lWidth, lHeight, MonoDC, 0, 0, vbSrcAnd
    SetRect R, 0, 0, lWidth, lHeight
    InvertRect MonoDC, R
    BitBlt AndDC, 0, 0, lWidth, lHeight, MonoDC, 0, 0, vbSrcAnd
    BitBlt CopyDC, 0, 0, lWidth, lHeight, AndDC, 0, 0, vbSrcPaint
    
    If BitBlt(hDestDC, 0, 0, lWidth, lHeight, CopyDC, 0, 0, vbSrcCopy) = 0 Then Exit Function
    DeleteObject MonoBitmap
    DeleteObject CopyBitmap
    DeleteObject AndBitmap
    DeleteDC MonoDC
    DeleteDC CopyDC
    DeleteDC AndDC
    TransBlt = True
End Function
Function ChangePixels(hSrcDC As Long, lWidth As Integer, lHeight As Integer, OldColor As Long, NewColor As Long, hDestDC As Long) As Boolean
    Dim R As RECT, mBrush As Long, CopyDC As Long, CopyBitmap As Long
    SetRect R, 0, 0, lWidth, lHeight
    mBrush = CreateSolidBrush(NewColor)
    CopyDC = CreateCompatibleDC(hSrcDC)
    CopyBitmap = CreateCompatibleBitmap(hSrcDC, lWidth, lHeight)
    If SelectObject(CopyDC, CopyBitmap) = 0 Then Exit Function
    If FillRect(CopyDC, R, mBrush) = 0 Then Exit Function

    If TransBlt(hSrcDC, lWidth, lHeight, OldColor, CopyDC, hDestDC) = False Then Exit Function

    DeleteDC CopyDC
    DeleteObject CopyBitmap
    ChangePixels = True
End Function
Function DrawMirrorBitmap(hSrcDC As Long, nWidth As Integer, nHeight As Integer, Horizontal As Boolean, Vertical As Boolean, hDestDC As Long) As Boolean
    If Horizontal And Vertical Then
        If StretchBlt(hDestDC, 0, 0, nWidth, nHeight, hSrcDC, nWidth - 1, nHeight - 1, -nWidth, -nHeight, vbSrcCopy) = 0 Then Exit Function
    ElseIf Horizontal Then
        If StretchBlt(hDestDC, 0, 0, nWidth, nHeight, hSrcDC, 0, nHeight - 1, nWidth, -nHeight, vbSrcCopy) = 0 Then Exit Function
    ElseIf Vertical Then
        If StretchBlt(hDestDC, 0, 0, nWidth, nHeight, hSrcDC, nWidth - 1, 0, -nWidth, nHeight, vbSrcCopy) = 0 Then Exit Function
    Else
        If BitBlt(hDestDC, 0, 0, nWidth, nHeight, hSrcDC, 0, 0, vbSrcCopy) = 0 Then Exit Function
    End If
    DrawMirrorBitmap = True
End Function
Function CreateMyFont(FontName As String, nPointSize As Long, Bold As eBold, Italic As Boolean, Underlined As Boolean, StrikeOut As Boolean, Precision As ePrecision, Quality As eQuality, nRotationDegrees As Long, CharSet As eCharSet) As Long
    Dim nHeight As Long
    nHeight = -MulDiv(nPointSize, GetDeviceCaps(GetDC(0), LOGPIXELSY), 72)
    CreateMyFont = CreateFont(nHeight, 0, nRotationDegrees * 10, 0, Bold, Italic, Underlined, _
    StrikeOut, CharSet, Precision, CLIP_DEFAULT_PRECIS, Quality, DEFAULT_PITCH, FontName)
End Function
Function DrawRotatedText(sText As String, nDegrees As Long, hDestDC As Long) As Boolean
    Dim OldFont As Long, NewFont As Long
    OldFont = SelectObject(hDestDC, CreateMyFont("Times New Roman", 24, FW_NORMAL, True, False, False, OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, nDegrees, DEFAULT_CHARSET))
    If OldFont = 0 Then Exit Function
    If TextOut(hDestDC, 0, 0, sText, Len(sText)) = 0 Then Exit Function
    DeleteObject SelectObject(hDestDC, OldFont)
    DrawRotatedText = True
End Function
Function DrawButton(Left As Long, Top As Long, Right As Long, Bottom As Long, Edge As eEdge, Focus As Boolean, hDestDC As Long) As Boolean
    Dim R As RECT, mColor As Long, OldBrush As Long
    SetRect R, Left, Top, Right, Bottom
    mColor = GetSysColor(COLOR_BTNFACE)
    OldBrush = SelectObject(hDestDC, CreateSolidBrush(mColor))
    If Rectangle(hDestDC, Left, Top, Right, Bottom) = 0 Then Exit Function
    If DrawEdge(hDestDC, R, Edge, BF_RECT) = 0 Then Exit Function
    If Focus Then
        SetRect R, Left + 4, Top + 4, Right - 4, Bottom - 4
        If DrawFocusRect(hDestDC, R) = 0 Then Exit Function
    End If
    DeleteObject SelectObject(hDestDC, OldBrush)
    DrawButton = True
End Function
